// 注意: js文件中只能使用行注释
// 因为注释会导致调用webview.loadurl方法时报错
// 因此行注释在js代码被加载前会被去掉
// 原生app暴露给h5使用的interface对象
// 【注意！】最终发布的时候，请对此文件进行混淆加密！！！！！
window.gameBridge_core = window.gameBridge_core || {
    callNative: function () {
        alert('gameBridge_core模块没有加载成功！')
    }
};
var gameBridge = {
    // 保存回调方法
    responseCallbacks: {},

    checkAd: function (type, callback) {
        gameBridge.callNativeMethod('checkAd', [type], callback);
    },

    playAd: function (type, callback) {
        gameBridge.callNativeMethod('playAd', [type], callback, function (status) {
            // 广告播放结束并关闭或者取消回调才清理，因为会回调多次！
            return status == 10000 || status == 10001;
        });
    },

    submitRanking: function (score, callback) {
        gameBridge.callNativeMethod('submitRanking', [score], callback);
    },

    getHighScore: function (callback) {
        gameBridge.callNativeMethod('getHighScore', [], callback);
    },

    showRanking: function() {
        gameBridge.callNativeMethod('showRanking')
    },

    saveLocalData: function (data) {
        gameBridge.callNativeMethod('saveLocalData', [data]);
    },

    getLocalData: function (callback) {
        gameBridge.callNativeMethod('getLocalData', [], callback);
    },

    submitUserAction: function(type, message, callback) {
        gameBridge.callNativeMethod('submitUserAction', [type, message], callback);
    },

    // 调用Native方法
    callNativeMethod: function (methodName, params, callback, needDeleteCallbackFunction) {
        var callId = methodName + '-' + String(new Date().getTime());
        gameBridge.responseCallbacks[callId] = function (params) {
            callback.apply(this, params);
            var needDelete = true;
            if (typeof needDeleteCallbackFunction === 'function') {
                // 允许由调用者决定何时删除缓存
                needDelete = needDeleteCallbackFunction.apply(this, params);
            }
            if (needDelete) {
                gameBridge.responseCallbacks[callId] = undefined;
            }
        };
        gameBridge_core.callNative(callId, methodName, JSON.stringify(params || []));
    },

    // 供Native层调用的方法
    dispatchMessageFromNative: function (id, paramsJson) {
        setTimeout(function () {
            var params = JSON.parse(paramsJson);
            var callback;
            if (!(callback = gameBridge.responseCallbacks[id])) {
                alert('没有找到请求：' + id);
                return;
            }
            callback.call(this, params);
        });
    }
};
// 将gameBridge对象绑定到window.xsz上，这样游戏可以通过xsz.XXX来调用相关的方法
window.xsz = gameBridge;